top:-
	'VOID'(V),
	queens(6,Qs,V,V,V),
	fail.
top.

queens(N,Qs,_,S1,S2) :-
	range(1,N,Ns,S1,S2),
	'SOURCE'(-,-,-,+S12,+S22),
	queens2(Ns,[],Qs,S12,S22).

queens2(A,B,C,S1,S2) :-
	'VOID'(V),
	queens2INT(A,B,C,V,V),
	'SINK'(-,-,-,+S1,+S2).

queens2INT([],Qs,Qs,_,_).
queens2INT(UnplacedQs,SafeQs,Qs,_,_) :-
	'VOID'(V),
	select(UnplacedQs,UnplacedQs1,Q,V,V),%SafeQs,Qs),
%	'SOURCE'(-,-,-,+SafeQs2,+Qs2),
	not_attack(SafeQs,Q,V,SafeQs,Qs),
%	'SOURCE'(-,-,-,+SafeQs3,+Qs3),
	queens2INT(UnplacedQs1,[Q|SafeQs],Qs).

not_attack(Xs,X,_,S1,S2) :-
	not_attack(Xs,X,1,S1,S2).

not_attack([],_,_,S1,S2) :- 
	!,
	'SINK'(-,-,-,+S1,+S2).
not_attack([Y|Ys],X,N,S1,S2) :-
	X =\= Y+N, 
	X =\= Y-N,
	N1 is N+1,
	not_attack(Ys,X,N1,S1,S2).

select([X|Xs],Xs,X,S1,S2) :-
	'SINK'(-,-,-,+S1,+S2).
select([Y|Ys],[Y|Zs],X,S1,S2) :- 
	select(Ys,Zs,X,S1,S2).

range(N,N,[N],S1,S2) :- 
	!,
	'SINK'(-,-,-,+S1,+S2).
range(M,N,[M|Ns],S1,S2) :-
	M < N,
	M1 is M+1,
	range(M1,N,Ns,S1,S2).

'SINK'(_,_,_,_,_).

