:- ensure_loaded(['lib/list','lib/number']).

progs_regs_file(ProgsShorts, From-To, TablesFile) :-
	list_list_list_scheme(ProgsShorts, Progs, Shorts, (P-S)^P^S^true),
	open(TablesFile, append, Stream),
	format(Stream, "~N\\begin{center}~n\\small~n\\begin{tabular}{|r||", []),
	list_argument_scheme(Progs, Stream, _^S^format(S, "r|", [])),
	format(Stream, "} \\hline~n", []),
	list_argument_scheme(Shorts, Stream, P0^S^(phrase(progNameDCG(P0),P),format(S,"& \\multicolumn{1}{c|}{~s} ",[P]))),
	format(Stream, "\\\\ \\hline \\hline~n", []),
	int_for(I, From, To),
	format(Stream, "~d ", [I]),
	list_argument_scheme(Progs, Stream-I, P^(S-I)^prog_reg_stream(P,I,S)),
	format(Stream, "\\\\ \\hline~n", []),
	(I < To -> fail; true),
	!,
	format(Stream, "~N\\end{tabular}~n\\end{center}~n~n", []),
	close(Stream).

prog_reg_stream(Prog, I, Stream) :- 
	number_chars(I, IChars),
	lists_appended(["reg",IChars,"/",Prog,".instr"], FileInstrChars),
	atom_chars(FileInstr, FileInstrChars),
	open(FileInstr, read, InstrStream),
	read(InstrStream, instr(Instr0)),
	close(InstrStream),
	calibrateInstr(CalInstr),
	Instr is Instr0-CalInstr,
	format(Stream, "& ~d ", [Instr]).


progNameDCG([]) -->
	[].
progNameDCG([0'_|Cs]) -->
	!,
	"\\_",
	progNameDCG(Cs).
progNameDCG([C|Cs]) -->
	[C],
	progNameDCG(Cs).


calibrateInstr(112).


