:- use_module(library(insc)).

instrbench(FileName0) :-
	atom_chars(FileName0, FileName),
    	list_list_appended(FileName, ".ql", QlFile0),
	atom_chars(QlFile, QlFile0),
	load(QlFile),
	garbage_collect,
	prolog_flag(gc,_,off),
	run_(runbench, [instr-Instr]),
	list_list_appended(FileName, ".instr", OutFile0),
	atom_chars(OutFile, OutFile0), 
	open(OutFile, write, Stream),
	portray_clause(Stream, instr(Instr)),
	close(Stream).

runbench :-
	insc:start,
	top,
	insc:stop,
	show(instr).

calibr :-
	run_(runcalibr, [calibrate-Calibr]),
	format("Calibration: ~q~n", [Calibr]).

runcalibr :-
	insc:calibrate,
	show(calibrate).

list_list_appended([], Bs, Bs).
list_list_appended([A|As], Bs, [A|Cs]):-
        list_list_appended(As, Bs, Cs).

