:- ensure_loaded(['lib/list','lib/number']).

progs_regs_file_kind(ProgsShorts, From-To, TablesFile, KindOfTable) :-
	list_list_list_scheme(ProgsShorts, Progs, Shorts, (P-S)^P^S^true),
	open(TablesFile, append, Stream),
	format(Stream, "~N\\begin{center}~n\\footnotesize~n\\begin{tabular}{|r||", []),
	list_argument_scheme(Progs, Stream, _^S^format(S, "r|", [])),
	format(Stream, "} \\hline~n", []),
	list_argument_scheme(Shorts, Stream, P0^S^(phrase(progNameDCG(P0),P),format(S,"& \\multicolumn{1}{c|}{~s} ",[P]))),
	format(Stream, "\\\\ \\hline \\hline~n", []),
	int_for(I, From, To),
	format(Stream, "~d ", [I]),
	list_argument_scheme(Progs, Stream-I, P^(S-I)^prog_reg_stream_kind(P,I,S,KindOfTable)),
	format(Stream, "\\\\ \\hline~n", []),
	(I < To -> fail; true),
	!,
	format(Stream, "~N\\end{tabular}~n\\end{center}~n~n", []),
	close(Stream).

prog_reg_stream_kind(Prog, I, Stream, KindOfTable) :- 
	lists_appended(["orig/",Prog,".instr"], FileOrigChars),
	atom_chars(FileOrig, FileOrigChars),
	open(FileOrig, read, OrigStream),
	read(OrigStream, instr(OrigInstr0)),
	close(OrigStream),
	calibrateInstr(CalInstr),
	OrigInstr is OrigInstr0-CalInstr,
	number_chars(I, IChars),
	lists_appended(["reg",IChars,"/",Prog,".instr"], FileInstrChars),
	atom_chars(FileInstr, FileInstrChars),
	open(FileInstr, read, InstrStream),
	read(InstrStream, instr(Instr0)),
	close(InstrStream),
	Instr is Instr0-CalInstr,
	Speedup is OrigInstr/Instr,
    	(KindOfTable = speedup ->
	    format(Stream, "& ~4f ", [Speedup])
	;
	    format(Stream, "& ~d ", [Instr])
	).



progNameDCG([]) -->
	[].
progNameDCG([0'_|Cs]) -->
	!,
	"\\_",
	progNameDCG(Cs).
progNameDCG([C|Cs]) -->
	[C],
	progNameDCG(Cs).


calibrateInstr(112).


