-top :-
    +queens(6,Qs),
    -fail.
-top.

+queens(N,Qs) :-
	+range(1,N,Ns),
	+queens2(Ns,[],Qs).

+queens2([],Qs,Qs).
+queens2(UnplacedQs,SafeQs,Qs) :-
	+select(UnplacedQs,UnplacedQs1,Q),
	+not_attack(SafeQs,Q),
	+queens2(UnplacedQs1,[Q|SafeQs],Qs).

+not_attack(Xs,X) :-
	+not_attack2(Xs,X,1).

+not_attack2([],_,_) :- 
	-!.
+not_attack2([Y|Ys],X,N) :-
	-(X =\= Y+N), 
	-(X =\= Y-N),
	-(N1 is N+1),
	+not_attack2(Ys,X,N1).

+select([X|Xs],Xs,X).
+select([Y|Ys],[Y|Zs],X) :- 
	+select(Ys,Zs,X).


+range(N,N,[N]) :- 
	-!.
+range(M,N,[M|Ns]) :-
	-(M < N),
	-(M1 is M+1),
	+range(M1,N,Ns).



